function checkParameter(hObject, min, max)
% CHECKPARAMETER    Check if a parameter value is in the range [min,max].
%
%    Author:
%       Thomas Schaffter, PhD student
%       Thomas.Schaffter@epfl.ch
%       http://lis.epfl.ch/161219
%       Laboratory of Intelligent Systems (LIS)
%       Ecole Polytechnique Federale de Lausanne (EPFL)
%       CH-Suisse
%
%    Last modification: 3 nov 2009

value = str2double(get(hObject, 'String'));

if isnan(value)
    set(hObject, 'String', min);
elseif value >= max
    set(hObject, 'String', max);
elseif value < min
     set(hObject, 'String', min);
end